For the latest news and information visit The GNU Crypto project

## gnu.crypto.mode
Class OFB

    java.lang.Object
      |
      +--gnu.crypto.mode.BaseMode
            |
            +--gnu.crypto.mode.OFB

All Implemented Interfaces:
  java.lang.Cloneable, IBlockCipher, IMode

public class OFB
extends BaseMode
implements java.lang.Cloneable

The Output Feedback (OFB) mode is a confidentiality mode that requires a unique `IV` for every message that is ever encrypted under the given key. The OFB mode is defined as follows:

- OFB Encryption:
  - I1 = IV;
  - Ij = Oj -1 for j = 2...n;
  - Oj = CIPHK(Ij) for j = 1, 2...n;
  - Cj = Pj XOR Oj for j = 1, 2...n.
- OFB Decryption:
  - I1 = IV;
  - Ij = Oj -1 for j = 2...n;
  - Oj = CIPHK(Ij) for j = 1, 2...n;
  - Pj = Cj XOR Oj for j = 1, 2...n.

In OFB encryption, the `IV` is transformed by the forward cipher function to produce the first output block. The first output block is exclusive-ORed with the first plaintext block to produce the first ciphertext block. The first output block is then transformed by the forward cipher function to produce the second output block. The second output block is exclusive-ORed with the second plaintext block to produce the second ciphertext block, and the second output block is transformed by the forward cipher function to produce the third output block. Thus, the successive output blocks are produced from enciphering the previous output blocks, and the output blocks are exclusive-ORed with the corresponding plaintext blocks to produce the ciphertext blocks.

In OFB decryption, the `IV` is transformed by the forward cipher function to produce the first output block. The first output block is exclusive-ORed with the first ciphertext block to recover the first plaintext block. The first output block is then transformed by the forward cipher function to produce the second output block. The second output block is exclusive-ORed with the second ciphertext block to produce the second plaintext block, and the second output block is also transformed by the forward cipher function to produce the third output block. Thus, the successive output blocks are produced from enciphering the previous output blocks, and the output blocks are exclusive-ORed with the corresponding ciphertext blocks to recover the plaintext blocks.

In both OFB encryption and OFB decryption, each forward cipher function (except the first) depends on the results of the previous forward cipher function; therefore, multiple forward cipher functions cannot be performed in parallel. However, if the `IV` is known, the output blocks can be generated prior to the availability of the plaintext or ciphertext data.

The OFB mode requires a unique `IV` for every message that is ever encrypted under the given key. If, contrary to this requirement, the same `IV` is used for the encryption of more than one message, then the confidentiality of those messages may be compromised. In particular, if a plaintext block of any of these messages is known, say, the jth plaintext block, then the jth output of the forward cipher function can be determined easily from the jth ciphertext block of the message. This information allows the jth plaintext block of any other message that is encrypted using the same `IV` to be easily recovered from the jth ciphertext block of that message.

Confidentiality may similarly be compromised if any of the input blocks to the forward cipher function for the encryption of a message is used as the `IV` for the encryption of another message under the given key.

References:

1. Recommendation for Block Cipher Modes of Operation Methods and Techniques, Morris Dworkin.

Field Summary

Fields inherited from class gnu.crypto.mode.BaseMode
`cipher, cipherBlockSize, iv, lock, modeBlockSize, name, state`

Fields inherited from interface gnu.crypto.mode.IMode
`DECRYPTION, ENCRYPTION, IV, MODE_BLOCK_SIZE, STATE`

Fields inherited from interface gnu.crypto.cipher.IBlockCipher
`CIPHER_BLOCK_SIZE, KEY_MATERIAL`

Method Summary
`java.lang.Object` `clone()` Returns a clone of this instance.
`void` `decryptBlock(byte[] in, int i, byte[] out, int o)` Decrypts exactly one block of ciphertext.
`void` `encryptBlock(byte[] in, int i, byte[] out, int o)` Encrypts exactly one block of plaintext.
`void` `setup()` The initialisation phase of the concrete mode implementation.
`void` `teardown()` The termination phase of the concrete mode implementation.

Methods inherited from class gnu.crypto.mode.BaseMode
`blockSizes, currentBlockSize, defaultBlockSize, defaultKeySize, init, keySizes, name, reset, selfTest, update`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### clone

    public java.lang.Object clone()

  Description copied from interface: `IBlockCipher`

  Returns a clone of this instance.

  Specified by:
    `clone` in interface `IBlockCipher`
  Specified by:
    `clone` in class `BaseMode`
  Returns:
    a clone copy of this instance.

### setup

    public void setup()

  Description copied from class: `BaseMode`
  The initialisation phase of the concrete mode implementation.

  Specified by:
    `setup` in class `BaseMode`

### teardown

    public void teardown()

  Description copied from class: `BaseMode`
  The termination phase of the concrete mode implementation.

  Specified by:
    `teardown` in class `BaseMode`

### encryptBlock

    public void encryptBlock(byte[] in,
                             int i,
                             byte[] out,
                             int o)

  Description copied from interface: `IBlockCipher`

  Encrypts exactly one block of plaintext.

  Specified by:
    `encryptBlock` in interface `IBlockCipher`
  Specified by:
    `encryptBlock` in class `BaseMode`
  Parameters:
    `in` - the plaintext.
    `i` - index of `in` from which to start considering data.
    `out` - the ciphertext.
    `o` - index of `out` from which to store result.

### decryptBlock

    public void decryptBlock(byte[] in,
                             int i,
                             byte[] out,
                             int o)

  Description copied from interface: `IBlockCipher`

  Decrypts exactly one block of ciphertext.

  Specified by:
    `decryptBlock` in interface `IBlockCipher`
  Specified by:
    `decryptBlock` in class `BaseMode`
  Parameters:
    `in` - the plaintext.
    `i` - index of `in` from which to start considering data.
    `out` - the ciphertext.
    `o` - index of `out` from which to store result.

For the latest news and information visit The GNU Crypto project

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.